#ifndef BatchLab_RangeSet_h
#define BatchLab_RangeSet_h

// Inheritance :
#include <AIDA/IRangeSet.h>

namespace BatchLab {

class RangeSet : public virtual AIDA::IRangeSet {
public: 
  virtual const std::vector<double>& lowerBounds();
  virtual const std::vector<double>& upperBounds();
  virtual void include(double xMin, double xMax);
  virtual void exclude(double xMin, double xMax);
  virtual void includeAll();
  virtual void excludeAll();
  virtual bool isInRange(double point);
  virtual int size();
  virtual double PLUS_INF();
  virtual double MINUS_INF();
public:
  virtual ~RangeSet();
private:
  std::vector<double> fMins;
  std::vector<double> fMaxs;
};

}

#endif
