#ifndef Lib_CoreDictionary_h
#define Lib_CoreDictionary_h

// Inheritance :
#include <Slash/Meta/IClass.h>
#include <Slash/Meta/IDictionary.h>
#include <Slash/Core/IManager.h>

#include <vector>

namespace Slash { namespace Core {class IWriter;}}

namespace Lib {

class Class : public virtual Slash::Meta::IClass {
public: //Lib::IClass
  virtual std::string name() const;
  virtual unsigned int version() const;
  virtual Slash::Meta::IObject* create();
public:
  typedef Slash::Meta::IObject*(*Allocator)(Slash::Core::IWriter&);
public:
  Class(Slash::Core::IWriter&,const std::string&,unsigned int,Allocator = 0);
  virtual ~Class();
private:
  Slash::Core::IWriter& fPrinter;
  std::string fName;
  unsigned int fVersion;
  Allocator fAllocator;
};

class Dictionary 
:public virtual Slash::Core::IManager
,public virtual Slash::Meta::IDictionary 
{
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //Lib::IDictionary
  virtual Slash::Meta::IClass* find(const std::string&) const;
  virtual bool add(Slash::Meta::IClass*);
  virtual unsigned int numberOfClasses() const;
  virtual const Slash::Meta::IClass* getClass(unsigned int index) const;
public:
  Dictionary(Slash::Core::IWriter&);
  virtual ~Dictionary();
private:
  std::string fName;
  Slash::Core::IWriter& fPrinter;
  std::vector<Slash::Meta::IClass*> fClasses;
  Slash::Meta::IClass* fNoneClass;
};

}

#endif

