#ifndef Lib_System_h
#define Lib_System_h

#include <string>
#include <vector>

namespace Lib {

class System {
public:
  static bool kind(std::string&);
  static bool isKindOf(const std::string&);
  static bool isWindows_NT();
  static bool isUNIX();
  static bool isVMS();
  static bool type(std::string&);
  static bool isTypeOf(const std::string&);
  static bool isenv(const std::string&);
  static std::string getenv(const std::string&);
  static bool getenv(const std::string&,std::string&);
  static bool putenv(const std::string&,const std::string&);
  static bool envAppend(const std::string& env,
                        const std::string& value,
                        const std::string& separator);
  static bool envPathAppend(const std::string& env,
                            const std::string& value);
  static int execute(const std::string&);
  static void exit();
  static std::string pathSeparator();
  static std::string fileSeparator();
  static std::string quote(const std::string&);
  static std::string fortranUnitFormat();
  static int exitFailure();
  static int exitSuccess();
  static std::string dllPrefix();
  static std::string dllSuffix();
  static void sleep(unsigned int);
  //static bool exeName(std::string&);
  //static bool args(std::vector<std::string>&);
};

}

#endif

