#ifndef Lib_cstring_h
#define Lib_cstring_h 

#include <string.h> /* strcpy */
#include <stdlib.h> /* malloc,free */

#define Lib_strdup(str)  ((str) != NULL ? (::strcpy((char*)::malloc((unsigned)::strlen(str) + 1), str)) : (char*)NULL)
#define Lib_strdel(str) {if((str)!=NULL) {::free((void*)(str));str=NULL;}}

#include <vector>

//////////////////////////////////////////////////////////////////////////////
inline unsigned int Lib_strtods(
 const char* aCString 
,std::vector<double>& aValues
,bool aFixed = false
)
//////////////////////////////////////////////////////////////////////////////
// aFixed = false : aValues size is adapted according to what is read.
// aFixed = true : aValues size is fixed. If less is read, then the
//                 rest is pad with 0.
// return : the number of double read.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int n = aValues.size();
  char* begin = (char*)aCString;
  char* end;
  double d;
  unsigned int index = 0;
  std::vector<double>::iterator it = aValues.begin();
  while(true) {  
    d = ::strtod(begin,&end);
    if(end==begin) {
      if(aFixed) {
        for(;it!=aValues.end();++it) *it = 0;
      } else {
        if(index<n) aValues.resize(index);
      }
      return index;
    }
    if(index<n) {
      *it = d;
      it++;
    } else {
      if(aFixed) return index;
      aValues.push_back(d);
    }
    index++;
    begin = end;
  }
}

#endif
